<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCustomerBillingIssueTypeEnum ArrayType
 * @subpackage Arrays
 */
class ArrayOfCustomerBillingIssueTypeEnum extends AbstractStructArrayBase
{
    /**
     * The CustomerBillingIssueTypeEnum
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $CustomerBillingIssueTypeEnum;
    /**
     * Constructor method for ArrayOfCustomerBillingIssueTypeEnum
     * @uses ArrayOfCustomerBillingIssueTypeEnum::setCustomerBillingIssueTypeEnum()
     * @param string[] $customerBillingIssueTypeEnum
     */
    public function __construct(array $customerBillingIssueTypeEnum = array())
    {
        $this
            ->setCustomerBillingIssueTypeEnum($customerBillingIssueTypeEnum);
    }
    /**
     * Get CustomerBillingIssueTypeEnum value
     * @return string[]|null
     */
    public function getCustomerBillingIssueTypeEnum()
    {
        return $this->CustomerBillingIssueTypeEnum;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomerBillingIssueTypeEnum method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomerBillingIssueTypeEnum method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomerBillingIssueTypeEnumForArrayConstraintsFromSetCustomerBillingIssueTypeEnum(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCustomerBillingIssueTypeEnumCustomerBillingIssueTypeEnumItem) {
            // validation for constraint: enumeration
            if (!\CustomerManagement\EnumType\CustomerBillingIssueTypeEnum::valueIsValid($arrayOfCustomerBillingIssueTypeEnumCustomerBillingIssueTypeEnumItem)) {
                $invalidValues[] = is_object($arrayOfCustomerBillingIssueTypeEnumCustomerBillingIssueTypeEnumItem) ? get_class($arrayOfCustomerBillingIssueTypeEnumCustomerBillingIssueTypeEnumItem) : sprintf('%s(%s)', gettype($arrayOfCustomerBillingIssueTypeEnumCustomerBillingIssueTypeEnumItem), var_export($arrayOfCustomerBillingIssueTypeEnumCustomerBillingIssueTypeEnumItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \CustomerManagement\EnumType\CustomerBillingIssueTypeEnum', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \CustomerManagement\EnumType\CustomerBillingIssueTypeEnum::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CustomerBillingIssueTypeEnum value
     * @uses \CustomerManagement\EnumType\CustomerBillingIssueTypeEnum::valueIsValid()
     * @uses \CustomerManagement\EnumType\CustomerBillingIssueTypeEnum::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $customerBillingIssueTypeEnum
     * @return \CustomerManagement\ArrayType\ArrayOfCustomerBillingIssueTypeEnum
     */
    public function setCustomerBillingIssueTypeEnum(array $customerBillingIssueTypeEnum = array())
    {
        // validation for constraint: array
        if ('' !== ($customerBillingIssueTypeEnumArrayErrorMessage = self::validateCustomerBillingIssueTypeEnumForArrayConstraintsFromSetCustomerBillingIssueTypeEnum($customerBillingIssueTypeEnum))) {
            throw new \InvalidArgumentException($customerBillingIssueTypeEnumArrayErrorMessage, __LINE__);
        }
        $this->CustomerBillingIssueTypeEnum = is_array($customerBillingIssueTypeEnum) ? implode(' ', $customerBillingIssueTypeEnum) : null;
        return $this;
    }
    /**
     * Add item to CustomerBillingIssueTypeEnum value
     * @uses \CustomerManagement\EnumType\CustomerBillingIssueTypeEnum::valueIsValid()
     * @uses \CustomerManagement\EnumType\CustomerBillingIssueTypeEnum::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \CustomerManagement\ArrayType\ArrayOfCustomerBillingIssueTypeEnum
     */
    public function addToCustomerBillingIssueTypeEnum($item)
    {
        // validation for constraint: enumeration
        if (!\CustomerManagement\EnumType\CustomerBillingIssueTypeEnum::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \CustomerManagement\EnumType\CustomerBillingIssueTypeEnum', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \CustomerManagement\EnumType\CustomerBillingIssueTypeEnum::getValidValues())), __LINE__);
        }
        $this->CustomerBillingIssueTypeEnum[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \CustomerManagement\EnumType\CustomerBillingIssueTypeEnum::valueIsValid()
     * @param string $item
     * @return \CustomerManagement\ArrayType\ArrayOfCustomerBillingIssueTypeEnum
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\CustomerManagement\EnumType\CustomerBillingIssueTypeEnum::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \CustomerManagement\EnumType\CustomerBillingIssueTypeEnum', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \CustomerManagement\EnumType\CustomerBillingIssueTypeEnum::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CustomerBillingIssueTypeEnum
     */
    public function getAttributeName()
    {
        return 'CustomerBillingIssueTypeEnum';
    }
}
